// DO NOT EDIT: auto-generated with `pub run custom_element_apigen:update`

/// Dart API for the polymer element `paper_fab_menu`.
library paper_fab_menu.paper_fab_menu;

import 'dart:html';
import 'dart:js' show JsArray, JsObject;
import 'package:web_components/interop.dart' show registerDartType;
import 'package:polymer/polymer.dart' show initMethod;
import 'package:custom_element_apigen/src/common.dart' show PolymerProxyMixin, DomProxyMixin;

/// `paper-fab-menu` creates a floating action button menu with paper elements. By default, the menu will be hide. Use `opened` or `toggle()` to show/hide the menu. On mobile device, tooltip is automatically shown, otherwise it will be hidden on desktop browsers.
///
/// ##### Example
///
///     <paper-fab-menu icon="menu" closeIcon="close" duration="0.3">
///       <paper-fab-menu-item icon="info-outline" color="blue;" tooltip="Information"></paper-fab-menu-item>
///       <paper-fab-menu-item icon="alarm" color="purple;" tooltip="Alarm"></paper-fab-menu-item>
///       <paper-fab-menu-item icon="star-outline" color="green;" tooltip="Favorites"></paper-fab-menu-item>
///       <paper-fab-menu-item icon="list" color="orange;" tooltip="List"></paper-fab-menu-item>
///     </paper-fab-menu>
class PaperFabMenu extends HtmlElement with DomProxyMixin, PolymerProxyMixin {
  PaperFabMenu.created() : super.created();
  factory PaperFabMenu() => new Element.tag('paper-fab-menu');

  /// Set the default icon of main button to show floating menu
  String get icon => jsElement[r'icon'];
  set icon(String value) { jsElement[r'icon'] = value; }

  /// Set the icon of main button to close floating menu
  String get closeIcon => jsElement[r'closeIcon'];
  set closeIcon(String value) { jsElement[r'closeIcon'] = value; }

  /// Set duration of total animation to show/hide menu. This will be seed value to determine delay and duration of each menu item.
  get duration => jsElement[r'duration'];
  set duration(value) { jsElement[r'duration'] = (value is Map || value is Iterable) ? new JsObject.jsify(value) : value;}

  /// Set z-index of container to contain whole parts of menu. This will be depth to determine z-orders of elements including paper-fab-menu.
  get zIndex => jsElement[r'zIndex'];
  set zIndex(value) { jsElement[r'zIndex'] = (value is Map || value is Iterable) ? new JsObject.jsify(value) : value;}

  /// Set opened to true to show the floating menu and to false to hide it.
  bool get opened => jsElement[r'opened'];
  set opened(bool value) { jsElement[r'opened'] = value; }

  /// Automactically set delay to each item. This will be deprecated at later version.
  JsArray get items => jsElement[r'items'];
  set items(JsArray value) { jsElement[r'items'] = (value is Iterable) ? new JsObject.jsify(value) : value;}

  /// The `toggle` method will toggle the state of menu.
  void toggle() =>
      jsElement.callMethod('toggle', []);

  /// The `open` method will show the menu.
  void open() =>
      jsElement.callMethod('open', []);

  /// The `close` method will hide the menu.
  void close() =>
      jsElement.callMethod('close', []);
}
@initMethod
upgradePaperFabMenu() => registerDartType('paper-fab-menu', PaperFabMenu);
